## wasmedge 0.13.4+dfsg

=== CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2022 Second State INC

cmake_minimum_required(VERSION 3.15)
cmake_policy(SET CMP0091 NEW)
if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.24.0")
  cmake_policy(SET CMP0135 NEW)
endif()
project(WasmEdge)

# Overwrite it if you want to use static MSVC runtime library.
set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDLL")

set(WASMEDGE_CAPI_VERSION "0.0.3" CACHE STRING "WasmEdge C API library version")
set(WASMEDGE_CAPI_SOVERSION "0" CACHE STRING "WasmEdge C API library soversion")

find_program(GIT_CMD git)
execute_process(COMMAND
  ${GIT_CMD} describe --match "[0-9].[0-9]*" --tag
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  OUTPUT_VARIABLE CPACK_PACKAGE_VERSION
  RESULT_VARIABLE GIT_VERSION_NOT_FOUND
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

if(GIT_VERSION_NOT_FOUND AND NOT GIT_VERSION_NOT_FOUND EQUAL 0)
  set(CPACK_PACKAGE_VERSION "0.0.0-unreleased")
endif()

# Overwrite version information once there is a VERSION file
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/VERSION")
  file(READ "${CMAKE_CURRENT_SOURCE_DIR}/VERSION" LOCAL_VERSION)
  set(CPACK_PACKAGE_VERSION ${LOCAL_VERSION})
  unset(LOCAL_VERSION)
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

include(FetchContent)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Filesystem REQUIRED Final Experimental)
find_package(Threads REQUIRED)

# List of WasmEdge options
option(WASMEDGE_BUILD_TESTS "Generate build targets for the wasmedge unit tests." OFF)
option(WASMEDGE_BUILD_COVERAGE "Generate coverage report. Require WASMEDGE_BUILD_TESTS." OFF)
option(WASMEDGE_BUILD_AOT_RUNTIME "Enable WasmEdge LLVM-based ahead of time compilation runtime." ON)
option(WASMEDGE_BUILD_SHARED_LIB "Generate the WasmEdge shared library." ON)
option(WASMEDGE_BUILD_STATIC_LIB "Generate the WasmEdge static library." OFF)
option(WASMEDGE_BUILD_TOOLS "Generate wasmedge and wasmedgec tools. Depend on and will build the WasmEdge shared library." ON)
option(WASMEDGE_BUILD_FUZZING "Generate fuzzing test tools. Couldn't build with wasmedge tools and unit tests." OFF)
option(WASMEDGE_BUILD_PLUGINS "Generate plugins." ON)
option(WASMEDGE_BUILD_EXAMPLE "Generate examples." OFF)
option(WASMEDGE_FORCE_DISABLE_LTO "Forcefully disable link time optimization when linking even in Release/RelWithDeb build." OFF)
option(WASMEDGE_LINK_LLVM_STATIC "Statically link the LLVM library into the WasmEdge tools and libraries." OFF)
option(WASMEDGE_LINK_TOOLS_STATIC "Statically link the wasmedge and wasmedgec tools. Will forcefully link the LLVM library statically." OFF)
option(WASMEDGE_ENABLE_UB_SANITIZER "Enable undefined behavior sanitizer." OFF)
set(WASMEDGE_PLUGIN_WASI_NN_BACKEND "" CACHE STRING "Enable WasmEdge Wasi-NN plugin with backends.")
# Currently supported WASI-NN backend: "OpenVINO" on Linux x86_64
option(WASMEDGE_PLUGIN_WASI_CRYPTO "Enable WasmEdge Wasi-crypto plugin." OFF)
option(WASMEDGE_PLUGIN_WASI_LOGGING "Enable WasmEdge wasi-logging plugin." OFF)
option(WASMEDGE_PLUGIN_WASM_BPF "Enable WasmEdge wasm-bpf plugin." OFF)
option(WASMEDGE_PLUGIN_OPENCVMINI "Enable WasmEdge opencvmini plugin." OFF)
option(WASMEDGE_PLUGIN_PROCESS "Enable WasmEdge process plugin." OFF)
option(WASMEDGE_PLUGIN_IMAGE "Enable WasmEdge image plugin." OFF)
option(WASMEDGE_PLUGIN_TENSORFLOW "Enable WasmEdge TensorFlow plugin." OFF)
option(WASMEDGE_PLUGIN_TENSORFLOWLITE "Enable WasmEdge TensorFlow-Lite plugin." OFF)
option(WASMEDGE_PLUGIN_RUSTLS "Enable WasmEdge Rustls plugin." OFF)
option(WASMEDGE_DISABLE_LIBTINFO "Disable linking against libtinfo when linking LLVM" OFF)

if(WASMEDGE_BUILD_TOOLS AND WASMEDGE_BUILD_FUZZING)
  message(FATAL_ERROR "wasmedge tool and fuzzing tool are exclusive options.")
endif()
if(WASMEDGE_BUILD_TESTS AND WASMEDGE_BUILD_FUZZING)
  message(FATAL_ERROR "unit tests and fuzzing tool are exclusive options.")
endif()

if(WASMEDGE_BUILD_STATIC_LIB)
  # Static library will forcefully turn of the LTO.
  set(WASMEDGE_FORCE_DISABLE_LTO ON)
endif()
if(WASMEDGE_BUILD_TOOLS)
  if(WASMEDGE_LINK_TOOLS_STATIC)
    # Static tools will link LLVM statically.
    set(WASMEDGE_LINK_LLVM_STATIC ON)
    # Tools will forcefully turn on the static library building.
    set(WASMEDGE_BUILD_STATIC_LIB ON)
    if(WASMEDGE_BUILD_PLUGINS)
      message(WARNING "For tuning on the WASMEDGE_LINK_TOOLS_STATIC option, the plugins will not work.")
    endif()
  else()
    # Tools will forcefully turn on the shared library building.
    set(WASMEDGE_BUILD_SHARED_LIB ON)
  endif()
endif()
if(WASMEDGE_BUILD_PLUGINS)
  if(WASMEDGE_BUILD_STATIC_LIB)
    set(WASMEDGE_LINK_PLUGINS_STATIC ON)
  endif()
endif()

set(WASMEDGE_BUILD_PACKAGE "DEB;RPM" CACHE STRING "Package generate types")
set(CPACK_PROJECT_CONFIG_FILE ${CMAKE_CURRENT_SOURCE_DIR}/cmake/cpack_config.cmake)

if(WASMEDGE_BUILD_COVERAGE)
  set(GCOVR_ADDITIONAL_ARGS "--exclude-unreachable-branches;--exclude-throw-branches")
  include(CodeCoverage)
  append_coverage_compiler_flags()
endif()

include(Helper)
include(GNUInstallDirs)

string(TOUPPER "${CMAKE_INSTALL_DEFAULT_COMPONENT_NAME}" CMAKE_INSTALL_DEFAULT_COMPONENT_NAME_UPCASE)
set(CPACK_PACKAGE_VENDOR Second State LLC)
set(CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION}-${CMAKE_SYSTEM_NAME}")
set(CPACK_STRIP_FILES ON)
set(CPACK_PACKAGE_CONTACT "Shen-Ta Hsieh <beststeve@secondstate.io>")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "High performance WebAssembly Virtual Machine")
set(CPACK_ARCHIVE_COMPONENT_INSTALL ON)
set(CPACK_ARCHIVE_${CMAKE_INSTALL_DEFAULT_COMPONENT_NAME_UPCASE}_FILE_NAME "${CPACK_PACKAGE_FILE_NAME}")
set(CPACK_RPM_COMPONENT_INSTALL ON)
set(CPACK_RPM_MAIN_COMPONENT ${CMAKE_INSTALL_DEFAULT_COMPONENT_NAME})
set(CPACK_RPM_PACKAGE_LICENSE "Apache 2.0")
set(CPACK_DEB_COMPONENT_INSTALL ON)
set(CPACK_DEBIAN_${CMAKE_INSTALL_DEFAULT_COMPONENT_NAME_UPCASE}_PACKAGE_NAME wasmedge)
set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
set(CPACK_DEBIAN_COMPRESSION_TYPE xz)
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/WasmEdge/WasmEdge/")
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
set(CPACK_DEBIAN_PACKAGE_CONTROL_STRICT_PERMISSION ON)
set(CPACK_GENERATOR "${WASMEDGE_BUILD_PACKAGE}")
set(CPACK_PACKAGE_DESCRIPTION "WasmEdge is a high performance, extensible, and hardware optimized WebAssembly Virtual Machine for cloud, AI, and blockchain applications.")

if(WASMEDGE_BUILD_TESTS)
  include(CTest)
  add_subdirectory(test)
endif()

add_subdirectory(include)
add_subdirectory(lib)
if(WASMEDGE_BUILD_PLUGINS AND WASMEDGE_BUILD_SHARED_LIB)
  add_subdirectory(plugins)
endif()
add_subdirectory(thirdparty)
if(WASMEDGE_BUILD_TOOLS OR WASMEDGE_BUILD_FUZZING)
  add_subdirectory(tools)
endif()
if(WASMEDGE_BUILD_EXAMPLE)
  add_subdirectory(examples/plugin/get-string)
endif()

include(CPack)
include(CPackComponent)

=== plugins/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2022 Second State INC

if(WASMEDGE_PLUGIN_WASI_NN_BACKEND)
  add_subdirectory(wasi_nn)
endif()

if(WASMEDGE_PLUGIN_WASI_CRYPTO)
  add_subdirectory(wasi_crypto)
endif()

if(WASMEDGE_PLUGIN_IMAGE)
  # Only Linux and MacOS support wasmedge_image now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_image)
  else()
    message(WARNING "Only Linux and Darwin platforms support WasmEdge_Image plug-in now.")
  endif()
endif()

if(WASMEDGE_PLUGIN_TENSORFLOW)
  # Only Linux and MacOS support wasmedge_tensorflow now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_tensorflow)
  else()
    message(WARNING "Only Linux and Darwin platforms support WasmEdge_Tensorflow plug-in now.")
  endif()
endif()

if(WASMEDGE_PLUGIN_TENSORFLOWLITE)
  # Only Linux and MacOS support wasmedge_tensorflowlite now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_tensorflowlite)
  else()
    message(WARNING "Only Linux and Darwin platforms support WasmEdge_TensorflowLite plug-in now.")
  endif()
endif()

if(WASMEDGE_PLUGIN_PROCESS)
  # Only Linux systems support wasmedge_process now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    add_subdirectory(wasmedge_process)
  else()
    message(WARNING "Only Linux platforms support WasmEdge_Process plug-in now.")
  endif()
endif()

if(WASMEDGE_PLUGIN_WASM_BPF)
  # Only Linux systems support wasm_bpf now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    add_subdirectory(wasm_bpf)
  else()
    message(WARNING "Only Linux platforms support wasm_bpf plug-in now.")
  endif()
endif()

if(WASMEDGE_PLUGIN_OPENCVMINI)
  # Only Linux and MacOS support wasmedge_opencvmini now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_opencvmini)
  else()
    message(WARNING "Only Linux and Darwin platforms support WasmEdge_OpenCVMini plug-in now.")
  endif()
endif()

if(WASMEDGE_PLUGIN_WASI_LOGGING)
  add_subdirectory(wasi_logging)
endif()

if(WASMEDGE_PLUGIN_RUSTLS)
  add_subdirectory(wasmedge_rustls)
endif()

=== test/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2022 Second State INC

find_package(GTest QUIET)
if(GTest_FOUND)
  set(GTEST_BOTH_LIBRARIES "${GTEST_BOTH_LIBRARIES};Threads::Threads")
else()
  FetchContent_Declare(
    GTest
    GIT_REPOSITORY https://github.com/google/googletest.git
    GIT_TAG        release-1.11.0
    GIT_SHALLOW    TRUE
  )
  set(BUILD_GMOCK OFF CACHE BOOL "Builds the googlemock subproject" FORCE)
  set(INSTALL_GTEST OFF CACHE BOOL "Enable installation of googletest. (Projects embedding googletest may want to turn this OFF.)" FORCE)
  get_property(
    compile_options
    DIRECTORY
    PROPERTY COMPILE_OPTIONS
  )
  set_property(
    DIRECTORY
    APPEND
    PROPERTY COMPILE_OPTIONS
    ${WASMEDGE_CFLAGS}
    -Wno-language-extension-token
    -Wno-missing-noreturn
    -Wno-shift-sign-overflow
    -Wno-undef
    -Wno-unused-member-function
    -Wno-zero-as-null-pointer-constant
    -Wno-deprecated
  )
  if(NOT CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
    set_property(
      DIRECTORY
      APPEND
      PROPERTY COMPILE_OPTIONS
      -Wno-suggest-destructor-override
      -Wno-suggest-override
    )
  endif()
  FetchContent_MakeAvailable(GTest)
  set_property(
    DIRECTORY
    PROPERTY COMPILE_OPTIONS
    ${compile_options}
  )
  unset(compile_options)
  set(GTEST_BOTH_LIBRARIES "gtest;gtest_main")
endif()

if (WASMEDGE_BUILD_AOT_RUNTIME)
  add_subdirectory(aot)
  add_subdirectory(mixcall)
endif()
add_subdirectory(common)
add_subdirectory(spec)
add_subdirectory(loader)
add_subdirectory(executor)
add_subdirectory(thread)
if (WASMEDGE_BUILD_SHARED_LIB)
  add_subdirectory(api)
  add_subdirectory(externref)
endif()
if (WASMEDGE_BUILD_PLUGINS)
  add_subdirectory(plugins)
endif()
add_subdirectory(host/socket)
add_subdirectory(host/wasi)
add_subdirectory(host/mock)
add_subdirectory(expected)
add_subdirectory(span)
add_subdirectory(po)
add_subdirectory(memlimit)
add_subdirectory(errinfo)

if(WASMEDGE_BUILD_COVERAGE)
  setup_target_for_coverage_gcovr_html(
    NAME coverage
    EXECUTABLE ctest -j ${PROCESSOR_COUNT}
    DEPENDENCIES wasmedge
    BASE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    EXCLUDE
      "${PROJECT_SOURCE_DIR}/thirdparty/*"
      "${PROJECT_SOURCE_DIR}/test/*"
    )
  setup_target_for_coverage_gcovr_xml(
    NAME codecov
    EXECUTABLE ctest -j ${PROCESSOR_COUNT}
    DEPENDENCIES wasmedge
    EXCLUDE
      "${PROJECT_SOURCE_DIR}/thirdparty/*"
      "${PROJECT_SOURCE_DIR}/test/*"
    )
endif()

=== thirdparty/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2022 Second State INC

if(WASMEDGE_BUILD_AOT_RUNTIME)
  add_subdirectory(blake3)
endif()

add_subdirectory(ggml)

=== lib/aot/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2022 Second State INC

find_package(LLVM REQUIRED HINTS "${LLVM_CMAKE_PATH}")
get_filename_component(LLVM_DIR "${LLVM_DIR}" ABSOLUTE)
list(APPEND CMAKE_MODULE_PATH ${LLVM_DIR})
include(LLVMConfig)
include(AddLLVM)

get_filename_component(LLD_DIR "${LLVM_LIBRARY_DIR}/cmake/lld" ABSOLUTE)
find_package(LLD REQUIRED HINTS ${LLD_DIR})

if(WASMEDGE_LINK_LLVM_STATIC)
  wasmedge_add_library(wasmedgeAOT
    blake3.cpp
    cache.cpp
    compiler.cpp
  )

  target_link_libraries(wasmedgeAOT
    PUBLIC
    wasmedgeCommon
    wasmedgeSystem
    utilBlake3
    std::filesystem
    ${WASMEDGE_LLVM_LINK_STATIC_COMPONENTS}
    ${WASMEDGE_LLVM_LINK_SHARED_COMPONENTS}
  )
else()
  if(APPLE)
    list(APPEND LLD_LIBS lldMachO)
  elseif(WIN32)
    list(APPEND LLD_LIBS lldCOFF)
    set(EXTRA_COMPONENTS DebugInfoPDB LibDriver WindowsManifest)
  else()
    list(APPEND LLD_LIBS lldELF)
  endif()

  list(APPEND LLD_LIBS lldCommon)
  if(LLVM_VERSION_MAJOR LESS_EQUAL 13)
    list(APPEND LLD_LIBS lldDriver)
  endif()

  llvm_add_library(wasmedgeAOT
    blake3.cpp
    cache.cpp
    compiler.cpp
    LINK_LIBS
    wasmedgeCommon
    wasmedgeSystem
    utilBlake3
    ${LLD_LIBS}
    std::filesystem
    ${CMAKE_THREAD_LIBS_INIT}
    LINK_COMPONENTS
    core
    lto
    native
    nativecodegen
    option
    passes
    support
    transformutils
    ${EXTRA_COMPONENTS}
  )
endif()

wasmedge_setup_target(wasmedgeAOT)

target_include_directories(wasmedgeAOT
  SYSTEM
  PRIVATE
  ${LLVM_INCLUDE_DIR}
)

target_include_directories(wasmedgeAOT
  PUBLIC
  ${PROJECT_BINARY_DIR}/include
  ${PROJECT_SOURCE_DIR}/thirdparty/blake3
)

include(CheckCXXSourceCompiles)
set(CMAKE_REQUIRED_LINK_OPTIONS "-Wl,-lc,--exclude-libs=libc.a")
check_cxx_source_compiles("int main(){}" SUPPORT_EXCLUDE_LIBS)

if(SUPPORT_EXCLUDE_LIBS)
  file(GLOB LLD_ALL_LIBS ${LLVM_LIBRARY_DIR}/liblld*.a)
  list(TRANSFORM LLD_ALL_LIBS REPLACE "^.*/" "")
  string(JOIN : LLD_ALL_LIBS_COLON ${LLD_ALL_LIBS})
  target_link_options(wasmedgeAOT
    PUBLIC
    "SHELL:-Wl,--exclude-libs=${LLD_ALL_LIBS_COLON}"
  )
endif()

=== plugins/wasi_nn/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2022 Second State INC

wasmedge_add_library(wasmedgePluginWasiNN
  SHARED
  wasinnenv.cpp
  wasinnfunc.cpp
  wasinnmodule.cpp
  openvino.cpp
  onnx.cpp
  tf.cpp
  torch.cpp
  tfl.cpp
  ggml.cpp
)

target_compile_options(wasmedgePluginWasiNN
  PUBLIC
  -DWASMEDGE_PLUGIN
  -DGGML_USE_K_QUANTS
)

target_include_directories(wasmedgePluginWasiNN
  PUBLIC
  $<TARGET_PROPERTY:wasmedgePlugin,INCLUDE_DIRECTORIES>
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${PROJECT_SOURCE_DIR}/thirdparty/ggml
)

if(WASMEDGE_LINK_PLUGINS_STATIC)
  target_link_libraries(wasmedgePluginWasiNN
    PRIVATE
    wasmedgeCAPI
    utilGgml
  )
else()
  target_link_libraries(wasmedgePluginWasiNN
    PRIVATE
    wasmedge_shared
    utilGgml
  )
endif()

include(WASINNDeps)
wasmedge_setup_wasinn_target(wasmedgePluginWasiNN)

install(TARGETS wasmedgePluginWasiNN DESTINATION ${CMAKE_INSTALL_LIBDIR}/wasmedge)

=== test/plugins/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2022 Second State INC

if(WASMEDGE_PLUGIN_PROCESS)
  if (CMAKE_SYSTEM_NAME MATCHES "Linux")
    add_subdirectory(wasmedge_process)
  endif()
endif()

if(WASMEDGE_PLUGIN_WASI_NN_BACKEND)
  add_subdirectory(wasi_nn)
endif()

if(WASMEDGE_PLUGIN_WASI_CRYPTO)
  add_subdirectory(wasi_crypto)
endif()

if(WASMEDGE_PLUGIN_TENSORFLOW)
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_tensorflow)
  endif()
endif()

if(WASMEDGE_PLUGIN_TENSORFLOWLITE)
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_tensorflowlite)
  endif()
endif()

if(WASMEDGE_PLUGIN_IMAGE)
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_image)
  endif()
endif()

if(WASMEDGE_PLUGIN_OPENCVMINI)
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_opencvmini)
  endif()
endif()

if(WASMEDGE_PLUGIN_WASM_BPF)
  if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    add_subdirectory(wasm_bpf)
  endif()
endif()

if(WASMEDGE_PLUGIN_WASI_LOGGING)
  add_subdirectory(wasi_logging)
endif()

if(WASMEDGE_PLUGIN_RUSTLS)
  add_subdirectory(wasmedge_rustls)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "Linux" OR CMAKE_SYSTEM_NAME MATCHES "Darwin")
  add_subdirectory(unittest)
endif()

=== test/spec/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2022 Second State INC

include(FetchContent)

message(STATUS "Downloading the WASM spec test suite")
FetchContent_Declare(
  wasmedge_unit_test
  GIT_REPOSITORY https://github.com/second-state/WasmEdge-unittest
  GIT_TAG        wasm-dev-0.13.0
)
FetchContent_MakeAvailable(wasmedge_unit_test)
message(STATUS "Downloading the WASM spec test suite -- done")

find_package(simdjson QUIET)
if(simdjson_FOUND)
  message(STATUS "SIMDJSON found")
else()
  message(STATUS "Downloading SIMDJSON source")
  include(FetchContent)
  FetchContent_Declare(
    simdjson
    GIT_REPOSITORY https://github.com/simdjson/simdjson.git
    GIT_TAG  tags/v3.2.1
    GIT_SHALLOW TRUE)

  if( MSVC )
    get_property(
      compile_options
      DIRECTORY
      PROPERTY COMPILE_OPTIONS
      )
    set_property(
      DIRECTORY
      APPEND
      PROPERTY COMPILE_OPTIONS
      -Wno-undef
      -Wno-suggest-override
      -Wno-documentation
      -Wno-sign-conversion
      -Wno-extra-semi-stmt
      -Wno-old-style-cast
      -Wno-error=unused-parameter
      -Wno-error=unused-template
      -Wno-conditional-uninitialized
      -Wno-implicit-int-conversion
      -Wno-shorten-64-to-32
      -Wno-range-loop-bind-reference
      -Wno-format-nonliteral
      -Wno-unused-exception-parameter
      -Wno-unused-member-function
      )
    unset(compile_options)
  endif( MSVC )
  
  FetchContent_MakeAvailable(simdjson)

  set(SIMDJSON_JUST_LIBRARY ON CACHE INTERNAL "")
  set(SIMDJSON_BUILD_STATIC ON CACHE INTERNAL "")

  message(STATUS "Downloading SIMDJSON source -- done")
endif()

function(wasmedge_copy_spec_testsuite proposal)
  message(STATUS "Copying test suite to ${CMAKE_CURRENT_BINARY_DIR}/testSuites/${proposal}")
  file(COPY
    ${wasmedge_unit_test_SOURCE_DIR}/${proposal}
    DESTINATION
    ${CMAKE_CURRENT_BINARY_DIR}/testSuites
  )
  message(STATUS "Copying test suite to ${CMAKE_CURRENT_BINARY_DIR}/testSuites/${proposal} -- done")
endfunction()

foreach(PROPOSAL core multi-memory tail-call extended-const threads)
  wasmedge_copy_spec_testsuite(${PROPOSAL})
endforeach()

wasmedge_add_library(wasmedgeTestSpec
  spectest.cpp
)

target_link_libraries(wasmedgeTestSpec
  PRIVATE
  simdjson
  PUBLIC
  std::filesystem
  wasmedgeCommon
  ${GTEST_BOTH_LIBRARIES}
)

=== thirdparty/blake3/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2022 Second State INC

enable_language(ASM-ATT OPTIONAL)

if(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" OR CMAKE_SYSTEM_PROCESSOR STREQUAL "AMD64")
  set(SIMD_FILES
    blake3_avx2.c
    blake3_sse2.c
    blake3_sse41.c
  )
  set(SIMD_AVX512_FILES
    blake3_avx512.c
  )
  set(SIMD_UNIX_FILES
    blake3_avx2_x86-64_unix.S
    blake3_sse2_x86-64_unix.S
    blake3_sse41_x86-64_unix.S
  )
  set(SIMD_AVX512_UNIX_FILES
    blake3_avx512_x86-64_unix.S
  )
  set(SIMD_WIN_FILES
    blake3_avx2_x86-64_windows_gnu.S
    blake3_sse2_x86-64_windows_gnu.S
    blake3_sse41_x86-64_windows_gnu.S
  )
  set(SIMD_AVX512_WIN_FILES
    blake3_avx512_x86-64_unix.S
  )
  set_source_files_properties(blake3_avx2.c PROPERTIES COMPILE_FLAGS -mavx2)
  set_source_files_properties(blake3_sse2.c PROPERTIES COMPILE_FLAGS -msse2)
  set_source_files_properties(blake3_sse41.c PROPERTIES COMPILE_FLAGS -msse4.1)
  set(SIMD_DEFS)

  if(CMAKE_ASM-ATT_COMPILER_ID STREQUAL "GNU")
    execute_process(
      COMMAND ${CMAKE_ASM-ATT_COMPILER} --help
      OUTPUT_VARIABLE _gas_help
    )
    if(_gas_help MATCHES "avx512vl" OR _gas_help MATCHES "llvm")
      set(BLAKE3_AVX512 ON)
    else()
      set(BLAKE3_AVX512 OFF)
    endif()
  elseif(CMAKE_ASM-ATT_COMPILER_ID STREQUAL "Clang")
    set(BLAKE3_AVX512 ON)
  elseif(WIN32 AND CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(BLAKE3_AVX512 ON)
  endif()

  if(WIN32)
    set(SIMD_FILES ${SIMD_FILES} ${SIMD_WIN_FILES})
  else()
    set(SIMD_FILES ${SIMD_FILES} ${SIMD_UNIX_FILES})
  endif()

  if(BLAKE3_AVX512)
    set(SIMD_FILES ${SIMD_FILES} ${SIMD_AVX512_FILES})
    set_source_files_properties(blake3_avx512.c PROPERTIES COMPILE_FLAGS "-mavx512f -mavx512vl")
    if(WIN32)
      set(SIMD_FILES ${SIMD_FILES} ${SIMD_AVX512_WIN_FILES})
    else()
      set(SIMD_FILES ${SIMD_FILES} ${SIMD_AVX512_UNIX_FILES})
    endif()
  else()
    set(SIMD_DEFS ${SIMD_DEFS} -DBLAKE3_NO_AVX512)
  endif()

elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "(aarch64|arm64)")
  set(SIMD_FILES
    blake3_neon.c
  )
  set(SIMD_DEFS
    -DBLAKE3_USE_NEON
  )
else()
  set(SIMD_FILES)
  set(SIMD_DEFS)
endif()

wasmedge_add_library(utilBlake3
  blake3.c
  blake3_dispatch.c
  blake3_portable.c
  ${SIMD_FILES}
)

target_compile_options(utilBlake3
  PRIVATE
  -Wno-assign-enum
  -Wno-cast-align
  -Wno-cast-qual
  -Wno-implicit-int-conversion
  -Wno-language-extension-token
  -Wno-missing-prototypes
  -Wno-pointer-sign
  -Wno-shorten-64-to-32
  -Wno-sign-conversion
  -Wno-unused-function
)

target_include_directories(utilBlake3
  PUBLIC
  ${CMAKE_CURRENT_SOURCE_DIR}
)

target_compile_definitions(utilBlake3
  PRIVATE
  ${SIMD_DEFS}
)

=== thirdparty/ggml/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2022 Second State INC

wasmedge_add_library(utilGgml
  common.cpp
  ggml-alloc.c
  ggml.c
  k_quants.c
  ggml-alloc.c
  llama.cpp
)

target_compile_options(utilGgml
  PRIVATE
  -Wno-unused-parameter
  -Wno-unused-variable
  -Wno-unused-but-set-variable
  -Wno-unused-function
  -Wno-missing-braces
)

if(WIN32)
  target_compile_options(utilGgml
    PRIVATE
    -Wno-string-conversion
    -Wno-sign-conversion
    -Wno-macro-redefined
    -Wno-missing-prototypes
    -Wno-unreachable-code-return
    -Wno-shorten-64-to-32
    -Wno-implicit-int-conversion
    -Wno-implicit-float-conversion
    -Wno-float-conversion
    -Wno-unused-macros
    -Wno-unreachable-code-break
    -Wno-cast-align
    -Wno-undef
    -Wno-shadow-uncaptured-local
    -Wno-unreachable-code
    -Wno-cast-function-type
    -Wno-format-nonliteral
    -Wno-extra-semi-stmt
    -Wno-bad-function-cast
  )
endif()

target_include_directories(utilGgml
  PUBLIC
  ${CMAKE_CURRENT_SOURCE_DIR}
)

=== test/plugins/wasi_nn/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2022 Second State INC

wasmedge_add_executable(wasiNNTests
  wasi_nn.cpp
)

# Prepare the testing data for each backends.
foreach(BACKEND ${WASMEDGE_PLUGIN_WASI_NN_BACKEND})
  string(TOLOWER ${BACKEND} BACKEND)
  if(BACKEND MATCHES "openvino")
    message( STATUS "Download ML artifacts to ${CMAKE_CURRENT_BINARY_DIR}/wasinn_openvino_fixtures") 
    execute_process(
      COMMAND bash ${CMAKE_SOURCE_DIR}/utils/wasi-nn/download-openvino-fixtures.sh ${CMAKE_CURRENT_BINARY_DIR}/wasinn_openvino_fixtures
      RESULT_VARIABLE DOWNLOAD_ERROR
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    file(MD5 ${CMAKE_CURRENT_BINARY_DIR}/wasinn_openvino_fixtures/mobilenet.bin CHECKSUM_WEIGHT)
    file(MD5 ${CMAKE_CURRENT_BINARY_DIR}/wasinn_openvino_fixtures/mobilenet.xml CHECKSUM_DESCRIP)
    file(MD5 ${CMAKE_CURRENT_BINARY_DIR}/wasinn_openvino_fixtures/tensor-1x224x224x3-f32.bgr CHECKSUM_TENSOR)
    if(NOT CHECKSUM_WEIGHT STREQUAL "ae096b1f735f1e8e54bac8b2a42303bd")
      message(FATAL_ERROR "mobilenet.bin downloaded with wrong md5") 
    endif()
    if(NOT CHECKSUM_DESCRIP STREQUAL "4ea3a14273587ce5c1662018878f9f90")
      message(FATAL_ERROR "mobilenet.xml downloaded with wrong md5") 
    endif()
    if(NOT CHECKSUM_TENSOR STREQUAL "bfca546f4a3b5e6da49b7bd728e2799a")
      message(FATAL_ERROR "tensor-1x224x224x3-f32.bgr downloaded with wrong md5") 
    endif()
  elseif(BACKEND MATCHES "pytorch")
    message( STATUS "Download ML artifacts to ${CMAKE_CURRENT_BINARY_DIR}/wasinn_pytorch_fixtures") 
    execute_process(
      COMMAND bash ${CMAKE_SOURCE_DIR}/utils/wasi-nn/download-pytorch-fixtures.sh ${CMAKE_CURRENT_BINARY_DIR}/wasinn_pytorch_fixtures
      RESULT_VARIABLE DOWNLOAD_ERROR
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    file(MD5 ${CMAKE_CURRENT_BINARY_DIR}/wasinn_pytorch_fixtures/mobilenet.pt CHECKSUM_WEIGHT)
    file(MD5 ${CMAKE_CURRENT_BINARY_DIR}/wasinn_pytorch_fixtures/image-1x3x224x224.rgb CHECKSUM_IMAGE)
    if(NOT CHECKSUM_WEIGHT STREQUAL "234f446d2446e0f6fd8ed700c0b4b63b")
      message(FATAL_ERROR "mobilenet.pt downloaded with wrong md5") 
    endif()
    if(NOT CHECKSUM_IMAGE STREQUAL "551caa6f3b66c1d953655228462570a1")
      message(FATAL_ERROR "image-1x3x224x224.rgb downloaded with wrong md5") 
    endif()
  elseif(BACKEND STREQUAL "tensorflowlite")
    message( STATUS "Download ML artifacts to ${CMAKE_CURRENT_BINARY_DIR}/wasinn_tflite_fixtures") 
    execute_process(
      COMMAND bash ${CMAKE_SOURCE_DIR}/utils/wasi-nn/download-tflite-fixtures.sh ${CMAKE_CURRENT_BINARY_DIR}/wasinn_tflite_fixtures
      RESULT_VARIABLE DOWNLOAD_ERROR
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    file(MD5 ${CMAKE_CURRENT_BINARY_DIR}/wasinn_tflite_fixtures/lite-model_aiy_vision_classifier_birds_V1_3.tflite CHECKSUM_WEIGHT)
    file(MD5 ${CMAKE_CURRENT_BINARY_DIR}/wasinn_tflite_fixtures/birdx224x224x3.rgb CHECKSUM_IMAGE)
    if(NOT CHECKSUM_WEIGHT STREQUAL "3e59cc3a99afeeb819c2c38b319a7938")
      message(FATAL_ERROR "downloaded tflite model with wrong md5") 
    endif()
    if(NOT CHECKSUM_IMAGE STREQUAL "ad51c39cfe35d2ef35c4052b78cb3c55")
      message(FATAL_ERROR "downloaded bird.jpg fixture with wrong md5") 
    endif()
  else()
    # Add the other backend test files fetching here.
  endif()
endforeach()

add_dependencies(wasiNNTests
  wasmedgePluginWasiNN
)

include(WASINNDeps)
wasmedge_setup_wasinn_target(wasiNNTests)

target_include_directories(wasiNNTests
  PUBLIC
  $<TARGET_PROPERTY:wasmedgePlugin,INCLUDE_DIRECTORIES>
  $<TARGET_PROPERTY:wasmedgePluginWasiNN,INCLUDE_DIRECTORIES>
)

target_link_libraries(wasiNNTests
  PRIVATE
  ${GTEST_BOTH_LIBRARIES}
)
# Link to the WasmEdge library
if(WASMEDGE_LINK_PLUGINS_STATIC)
  target_link_libraries(wasiNNTests
    PRIVATE
    wasmedgeCAPI
  )
else()
  target_link_libraries(wasiNNTests
    PRIVATE
    wasmedge_shared
  )
endif()

add_test(wasiNNTests wasiNNTests)

=== debian/changelog ===
wasmedge (0.13.4+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Drop patch Drop-inline-from-Fault-emitFault, merged upstream.
  * Update debian/copyright with 2023 dates and newly shipped code.
  * Backport an upstream llama.cpp patch to fix a FTBFS with g++ 13.

 -- Faidon Liambotis <paravoid@debian.org>  Tue, 12 Sep 2023 17:30:20 +0300

wasmedge (0.13.3+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Drop libboost-all-dev dependency, as Boost was dropped as a dependency in
    the 0.13.0 release.
  * Fix FTBFS with gcc-13, by removing "inline" from Fault::emitFault.
    (Closes: #1042193)

 -- Faidon Liambotis <paravoid@debian.org>  Mon, 31 Jul 2023 16:47:02 +0300

wasmedge (0.13.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Drop several precompiled wasm files from Files-Excluded, as these have
      been dropped upstream at our request (see upstream #1869).
    - Add new symbols to libwasmedge0.symbols.
  * Drop wasmedgec, replaced upstream by "wasmedge compile".
    - Rename the manpage to wasmedge-compile(1) and adjust all references in
      wasmedge(1).
    - Adjust the package description & autopkgtests to refer to "wasmedge
      compile" (and "wasmedge run", where applicable) instead.
    - Stop shipping /usr/bin/wasmedgec.
  * autopkgtests: fix a failure in the "capi-wasi-env" test when build with a
    newer rustc, that ships with rust-lld -> lld-15, while llvm-defaults is
    still pointing to lld-14. See the inline comment and/or git commit message
    for more details.
  * Upload to unstable.

 -- Faidon Liambotis <paravoid@debian.org>  Wed, 12 Jul 2023 19:14:47 +0300

wasmedge (0.12.0~alpha2+dfsg-1) experimental; urgency=medium

  * Initial release. (Closes: #1003128)

 -- Faidon Liambotis <paravoid@debian.org>  Tue, 21 Mar 2023 17:34:06 +0200

=== debian/control ===
Source: wasmedge
Section: web
Priority: optional
Maintainer: Faidon Liambotis <paravoid@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 zlib1g-dev,
 libspdlog-dev,
 llvm-dev,
 liblld-dev,
 lowdown,
Standards-Version: 4.6.2
Homepage: https://wasmedge.org/
Vcs-Browser: https://salsa.debian.org/debian/wasmedge
Vcs-Git: https://salsa.debian.org/debian/wasmedge.git

Package: wasmedge
Architecture: amd64 arm64
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libwasmedge0 (= ${binary:Version}),
Description: standalone runtime for WebAssembly
 WasmEdge is a lightweight, high-performance, and extensible WebAssembly
 runtime for cloud native, edge, and decentralized applications.
 .
 It powers serverless apps, embedded functions, microservices, smart contracts,
 and IoT devices.
 .
 This package provides the general WASM runtime ("wasmedge run") as well as the
 ahead-of-time WASM compiler ("wasmedge compile").

Package: libwasmedge0
Section: libs
Architecture: amd64 arm64
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: standalone runtime for WebAssembly (C API shared library)
 WasmEdge is a lightweight, high-performance, and extensible WebAssembly
 runtime for cloud native, edge, and decentralized applications.
 .
 It powers serverless apps, embedded functions, microservices, smart contracts,
 and IoT devices.
 .
 This package provides the C API shared library.

Package: libwasmedge-dev
Section: libdevel
Architecture: amd64 arm64
Multi-Arch: same
Depends:
 ${misc:Depends},
 libwasmedge0 (= ${binary:Version}),
Description: standalone runtime for WebAssembly (development headers)
 WasmEdge is a lightweight, high-performance, and extensible WebAssembly
 runtime for cloud native, edge, and decentralized applications.
 .
 It powers serverless apps, embedded functions, microservices, smart contracts,
 and IoT devices.
 .
 This package provides the C API shared library development headers.

# A docs package for the book can be generated after mdBook is packaged for
# Debian; see #1004481 for the RFP
